Index: squid/src/peer_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/peer_select.c,v
retrieving revision 1.1.1.3.4.1.2.1
retrieving revision 1.1.1.3.4.1.2.1.2.1
diff -u -r1.1.1.3.4.1.2.1 -r1.1.1.3.4.1.2.1.2.1
--- squid/src/peer_select.c	6 Jan 2001 12:40:15 -0000	1.1.1.3.4.1.2.1
+++ squid/src/peer_select.c	27 Aug 2001 21:48:21 -0000	1.1.1.3.4.1.2.1.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: peer_select.c,v 1.1.1.3.4.1.2.1 2001/01/06 12:40:15 hno Exp $
+ * $Id: peer_select.c,v 1.1.1.3.4.1.2.1.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  * DEBUG: section 44    Peer Selection Algorithm
  * AUTHOR: Duane Wessels
@@ -35,8 +34,7 @@
 
 #include "squid.h"
 
-const char *hier_strings[] =
-{
+const char *hier_strings[] = {
     "NONE",
     "DIRECT",
     "SIBLING_HIT",
@@ -62,12 +60,13 @@
     "INVALID CODE"
 };
 
-static struct {
+static struct
+{
     int timeouts;
-} PeerStats;
+}
+PeerStats;
 
-static char *DirectStr[] =
-{
+static char *DirectStr[] = {
     "DIRECT_UNKNOWN",
     "DIRECT_NO",
     "DIRECT_MAYBE",
@@ -129,9 +128,7 @@
 
 void
 peerSelect(request_t * request,
-    StoreEntry * entry,
-    PSC * callback,
-    void *callback_data)
+    StoreEntry * entry, PSC * callback, void *callback_data)
 {
     ps_state *psstate = xcalloc(1, sizeof(ps_state));
     if (entry)
@@ -230,28 +227,19 @@
     StoreEntry *entry = ps->entry;
     request_t *request = ps->request;
     debug(44, 3) ("peerSelectFoo: '%s %s'\n",
-	RequestMethodStr[request->method],
-	request->host);
+	RequestMethodStr[request->method], request->host);
     if (ps->direct == DIRECT_UNKNOWN) {
 	if (ps->always_direct == 0 && Config.accessList.AlwaysDirect) {
-	    ps->acl_checklist = aclChecklistCreate(
-		Config.accessList.AlwaysDirect,
-		request,
-		NULL);		/* ident */
-	    aclNBCheck(ps->acl_checklist,
-		peerCheckAlwaysDirectDone,
-		ps);
+	    ps->acl_checklist =
+		aclChecklistCreate(Config.accessList.AlwaysDirect, request, NULL);	/* ident */
+	    aclNBCheck(ps->acl_checklist, peerCheckAlwaysDirectDone, ps);
 	    return;
 	} else if (ps->always_direct > 0) {
 	    ps->direct = DIRECT_YES;
 	} else if (ps->never_direct == 0 && Config.accessList.NeverDirect) {
-	    ps->acl_checklist = aclChecklistCreate(
-		Config.accessList.NeverDirect,
-		request,
-		NULL);		/* ident */
-	    aclNBCheck(ps->acl_checklist,
-		peerCheckNeverDirectDone,
-		ps);
+	    ps->acl_checklist =
+		aclChecklistCreate(Config.accessList.NeverDirect, request, NULL);	/* ident */
+	    aclNBCheck(ps->acl_checklist, peerCheckNeverDirectDone, ps);
 	    return;
 	} else if (ps->never_direct > 0) {
 	    ps->direct = DIRECT_NO;
@@ -260,8 +248,7 @@
 	} else {
 	    ps->direct = DIRECT_MAYBE;
 	}
-	debug(44, 3) ("peerSelectFoo: direct = %s\n",
-	    DirectStr[ps->direct]);
+	debug(44, 3) ("peerSelectFoo: direct = %s\n", DirectStr[ps->direct]);
     }
     if (entry == NULL) {
 	(void) 0;
@@ -324,9 +311,7 @@
 	ps->ping.n_sent = neighborsUdpPing(request,
 	    entry,
 	    peerHandlePingReply,
-	    ps,
-	    &ps->ping.n_replies_expected,
-	    &ps->ping.timeout);
+	    ps, &ps->ping.n_replies_expected, &ps->ping.timeout);
 	if (ps->ping.n_sent == 0)
 	    debug(44, 0) ("WARNING: neighborsUdpPing returned 0\n");
 	debug(44, 3) ("peerSelect: %d ICP replies expected, RTT %d msec\n",
@@ -334,10 +319,7 @@
 	if (ps->ping.n_replies_expected > 0) {
 	    entry->ping_status = PING_WAITING;
 	    eventAdd("peerPingTimeout",
-		peerPingTimeout,
-		ps,
-		0.001 * ps->ping.timeout,
-		0);
+		peerPingTimeout, ps, 0.001 * ps->ping.timeout, 0);
 	    return;
 	}
     }
@@ -416,8 +398,7 @@
     request_t *request = ps->request;
     hier_code code = HIER_NONE;
     debug(44, 3) ("peerGetSomeParent: %s %s\n",
-	RequestMethodStr[request->method],
-	request->host);
+	RequestMethodStr[request->method], request->host);
     if (ps->direct == DIRECT_YES)
 	return;
     if ((p = getDefaultParent(request))) {
@@ -497,8 +478,7 @@
     ps_state *psstate = data;
     icp_opcode op = header->opcode;
     debug(44, 3) ("peerHandleIcpReply: %s %s\n",
-	icp_opcode_str[op],
-	storeUrl(psstate->entry));
+	icp_opcode_str[op], storeUrl(psstate->entry));
 #if USE_CACHE_DIGESTS && 0
     /* do cd lookup to count false misses */
     if (p && request)
@@ -533,8 +513,7 @@
 {
     ps_state *psstate = data;
     debug(44, 3) ("peerHandleIcpReply: %s %s\n",
-	htcp->hit ? "HIT" : "MISS",
-	storeUrl(psstate->entry));
+	htcp->hit ? "HIT" : "MISS", storeUrl(psstate->entry));
     psstate->ping.n_recv++;
     if (htcp->hit) {
 	psstate->hit = p;
@@ -580,7 +559,8 @@
 #endif
 
 static void
-peerHandlePingReply(peer * p, peer_t type, protocol_t proto, void *pingdata, void *data)
+peerHandlePingReply(peer * p, peer_t type, protocol_t proto, void *pingdata,
+    void *data)
 {
     if (proto == PROTO_ICP)
 	peerHandleIcpReply(p, type, pingdata, data);
@@ -589,7 +569,8 @@
 	peerHandleHtcpReply(p, type, pingdata, data);
 #endif
     else
-	debug(44, 1) ("peerHandlePingReply: unknown protocol_t %d\n", (int) proto);
+	debug(44, 1) ("peerHandlePingReply: unknown protocol_t %d\n",
+	    (int) proto);
 }
 
 static void
@@ -597,8 +578,7 @@
 {
     FwdServer *fs = memAllocate(MEM_FWD_SERVER);
     debug(44, 5) ("peerAddFwdServer: adding %s %s\n",
-	p ? p->host : "DIRECT",
-	hier_strings[code]);
+	p ? p->host : "DIRECT", hier_strings[code]);
     fs->peer = p;
     fs->code = code;
     cbdataLock(fs->peer);
Index: squid/src/pinger.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/pinger.c,v
retrieving revision 1.1.1.3.4.1.2.1
retrieving revision 1.1.1.3.4.1.2.1.2.1
diff -u -r1.1.1.3.4.1.2.1 -r1.1.1.3.4.1.2.1.2.1
--- squid/src/pinger.c	6 Jan 2001 12:40:15 -0000	1.1.1.3.4.1.2.1
+++ squid/src/pinger.c	27 Aug 2001 21:48:21 -0000	1.1.1.3.4.1.2.1.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: pinger.c,v 1.1.1.3.4.1.2.1 2001/01/06 12:40:15 hno Exp $
+ * $Id: pinger.c,v 1.1.1.3.4.1.2.1.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  * DEBUG: section 42    ICMP Pinger program
  * AUTHOR: Duane Wessels
@@ -37,12 +36,65 @@
 
 #if USE_ICMP
 
+#ifndef _SQUID_MSWIN_
 #include <netinet/in_systm.h>
 #include <netinet/in.h>
 #include <netinet/ip.h>
 #include <netinet/ip_icmp.h>
+#else
+#include <winsock2.h>
+#include <process.h>
+
+#define ICMP_ECHO 8
+#define ICMP_ECHOREPLY 0
 
-#ifndef _SQUID_LINUX_
+typedef struct iphdr
+{
+    BYTE ip_vhl:4;		// Length of the header in dwords
+    BYTE version:4;		// Version of IP
+    BYTE tos;			// Type of service
+    USHORT total_len;		// Length of the packet in dwords
+    USHORT ident;		// unique identifier
+    USHORT flags;		// Flags
+    BYTE ip_ttl;		// Time to live
+    BYTE proto;			// Protocol number (TCP, UDP etc)
+    USHORT checksum;		// IP checksum
+    ULONG source_ip;
+    ULONG dest_ip;
+}
+iphdr;
+
+// ICMP header
+typedef struct icmphdr
+{
+    BYTE icmp_type;		// ICMP packet type
+    BYTE icmp_code;		// Type sub code
+    USHORT icmp_cksum;
+    USHORT icmp_id;
+    USHORT icmp_seq;
+    ULONG timestamp;		// not part of ICMP, but we need it
+}
+icmphdr;
+
+int
+xrename(const char *from, const char *to)
+{
+    debug(21, 2) ("xrename: renaming %s to %s\n", from, to);
+#ifdef _SQUID_MSWIN_
+    remove(to);
+#endif
+    if (0 == rename(from, to))
+	return 0;
+    debug(21, errno == ENOENT ? 2 : 1) ("xrename: Cannot rename %s to %s: %s\n",
+	from, to, xstrerror());
+    return -1;
+}
+
+static SOCKET squid_sock = -1;
+
+#endif
+
+#if !defined(_SQUID_LINUX_) && !defined(_SQUID_MSWIN_)
 #define icmphdr icmp
 #define iphdr ip
 #endif
@@ -80,17 +132,18 @@
 #define MAX_PKT_SZ (MAX_PAYLOAD + sizeof(struct timeval) + sizeof (char) + sizeof(struct icmphdr) + 1)
 #endif
 
-typedef struct {
+typedef struct
+{
     struct timeval tv;
     unsigned char opcode;
     char payload[MAX_PAYLOAD];
-} icmpEchoData;
+}
+icmpEchoData;
 
 int icmp_ident = -1;
 int icmp_pkts_sent = 0;
 
-static const char *icmpPktStr[] =
-{
+static const char *icmpPktStr[] = {
     "Echo Reply",
     "ICMP 1",
     "ICMP 2",
@@ -121,23 +174,97 @@
 pingerOpen(void)
 {
     struct protoent *proto = NULL;
+#ifdef _SQUID_MSWIN_
+    WSADATA wsaData;
+    WSAPROTOCOL_INFO wpi;
+    char buf[sizeof(wpi)];
+    int x;
+    struct sockaddr_in PS;
+
+    WSAStartup(2, &wsaData);
+
+    getCurrentTime();
+    _db_init(NULL, "ALL,1");
+    setmode(0, O_BINARY);
+    setmode(1, O_BINARY);
+    x = read(0, buf, sizeof(wpi));
+    if (x < sizeof(wpi)) {
+	getCurrentTime();
+	debug(42, 0) ("pingerOpen: read: FD 0: %s\n", xstrerror());
+	write(1, "ERR\n", 4);
+	exit(1);
+    }
+    xmemcpy(&wpi, buf, sizeof(wpi));
+
+    write(1, "OK\n", 3);
+    x = read(0, buf, sizeof(PS));
+    if (x < sizeof(PS)) {
+	getCurrentTime();
+	debug(42, 0) ("pingerOpen: read: FD 0: %s\n", xstrerror());
+	write(1, "ERR\n", 4);
+	exit(1);
+    }
+    xmemcpy(&PS, buf, sizeof(PS));
+#endif
     if ((proto = getprotobyname("icmp")) == 0) {
+	getCurrentTime();
 	debug(42, 0) ("pingerOpen: unknown protocol: icmp\n");
 	exit(1);
     }
     icmp_sock = socket(PF_INET, SOCK_RAW, proto->p_proto);
     if (icmp_sock < 0) {
+	getCurrentTime();
 	debug(50, 0) ("pingerOpen: icmp_sock: %s\n", xstrerror());
 	exit(1);
     }
     icmp_ident = getpid() & 0xffff;
     debug(42, 0) ("pinger: ICMP socket opened\n");
+#ifdef _SQUID_MSWIN_
+    squid_sock =
+	WSASocket(FROM_PROTOCOL_INFO, FROM_PROTOCOL_INFO, FROM_PROTOCOL_INFO,
+	&wpi, 0, 0);
+    if (squid_sock == INVALID_SOCKET) {
+	getCurrentTime();
+	debug(42, 0) ("pingerOpen: WSASocket: %s\n", xstrerror());
+	write(1, "ERR\n", 4);
+	exit(1);
+    }
+    x = connect(squid_sock, (struct sockaddr *) &PS, sizeof(PS));
+    if (SOCKET_ERROR == x) {
+	getCurrentTime();
+	debug(42, 0) ("pingerOpen: connect: %s\n", xstrerror());
+	write(1, "ERR\n", 4);
+	exit(1);
+    }
+    write(1, "OK\n", 3);
+    memset(buf, 0, sizeof(buf));
+    x = recv(squid_sock, buf, sizeof(buf), 0);
+    if (x < 3) {
+	debug(42, 0) ("icmpOpen: recv: %s\n", xstrerror());
+	exit(1);
+    }
+    x = send(squid_sock, buf, strlen(buf), 0);
+    if (x < 3 || strncmp("OK\n", buf, 3)) {
+	debug(42, 0) ("icmpOpen: recv: %s\n", xstrerror());
+	exit(1);
+    }
+
+    getCurrentTime();
+    debug(42, 0) ("pinger: Squid socket opened\n");
+#endif
 }
 
 void
 pingerClose(void)
 {
+#ifdef _SQUID_MSWIN_
+    closesocket(icmp_sock);
+    shutdown(squid_sock, SD_BOTH);
+    closesocket(squid_sock);
+    squid_sock = -1;
+#else
     close(icmp_sock);
+#endif
     icmp_sock = -1;
     icmp_ident = 0;
 }
@@ -185,10 +312,7 @@
     assert(icmp_pktsize <= MAX_PKT_SZ);
     sendto(icmp_sock,
 	pkt,
-	icmp_pktsize,
-	0,
-	(struct sockaddr *) &S,
-	sizeof(struct sockaddr_in));
+	icmp_pktsize, 0, (struct sockaddr *) &S, sizeof(struct sockaddr_in));
     pingerLog(icmp, to, 0, 0);
 }
 
@@ -210,17 +334,14 @@
 	pkt = xmalloc(MAX_PKT_SZ);
     fromlen = sizeof(from);
     n = recvfrom(icmp_sock,
-	pkt,
-	MAX_PKT_SZ,
-	0,
-	(struct sockaddr *) &from,
-	&fromlen);
+	pkt, MAX_PKT_SZ, 0, (struct sockaddr *) &from, &fromlen);
 #if GETTIMEOFDAY_NO_TZP
     gettimeofday(&now);
 #else
     gettimeofday(&now, NULL);
 #endif
-    debug(42, 9) ("pingerRecv: %d bytes from %s\n", n, inet_ntoa(from.sin_addr));
+    debug(42, 9) ("pingerRecv: %d bytes from %s\n", n,
+	inet_ntoa(from.sin_addr));
     ip = (struct iphdr *) (void *) pkt;
 #if HAVE_IP_HL
     iphdrlen = ip->ip_hl << 2;
@@ -276,10 +397,7 @@
 	(int) current_time.tv_sec,
 	(int) current_time.tv_usec,
 	inet_ntoa(addr),
-	(int) icmp->icmp_type,
-	icmpPktStr[icmp->icmp_type],
-	rtt,
-	hops);
+	(int) icmp->icmp_type, icmpPktStr[icmp->icmp_type], rtt, hops);
 }
 
 static int
@@ -305,7 +423,11 @@
     int n;
     int guess_size;
     memset(&pecho, '\0', sizeof(pecho));
+#ifdef _SQUID_MSWIN_
+    n = recv(squid_sock, (char *) &pecho, sizeof(pecho), 0);
+#else
     n = recv(0, (char *) &pecho, sizeof(pecho), 0);
+#endif
     if (n < 0)
 	return n;
     if (0 == n) {
@@ -321,10 +443,7 @@
 	/* don't process this message, but keep running */
 	return 0;
     }
-    pingerSendEcho(pecho.to,
-	pecho.opcode,
-	pecho.payload,
-	pecho.psize);
+    pingerSendEcho(pecho.to, pecho.opcode, pecho.payload, pecho.psize);
     return n;
 }
 
@@ -332,14 +451,18 @@
 pingerSendtoSquid(pingerReplyData * preply)
 {
     int len = sizeof(pingerReplyData) - MAX_PKT_SZ + preply->psize;
+#ifdef _SQUID_MSWIN_
+    if (send(squid_sock, (char *) preply, len, 0) < 0) {
+#else
     if (send(1, (char *) preply, len, 0) < 0) {
+#endif
 	debug(50, 0) ("pinger: send: %s\n", xstrerror());
+	pingerClose();
 	exit(1);
     }
 }
 
-time_t
-getCurrentTime(void)
+time_t getCurrentTime(void)
 {
 #if GETTIMEOFDAY_NO_TZP
     gettimeofday(&current_time);
@@ -365,8 +488,10 @@
  * drop privs
  */
     pingerOpen();
+#ifndef _SQUID_MSWIN_
     setgid(getgid());
     setuid(getuid());
+#endif
 
     if ((t = getenv("SQUID_DEBUG")))
 	debug_args = xstrdup(t);
@@ -374,25 +499,50 @@
     _db_init(NULL, debug_args);
 
     for (;;) {
+#ifdef _SQUID_MSWIN_
+	tv.tv_sec = 5;
+#else
 	tv.tv_sec = 10;
+#endif
 	tv.tv_usec = 0;
 	FD_ZERO(&R);
+#ifdef _SQUID_MSWIN_
+	FD_SET(squid_sock, &R);
+#else
 	FD_SET(0, &R);
+#endif
 	FD_SET(icmp_sock, &R);
 	x = select(icmp_sock + 1, &R, NULL, NULL, &tv);
 	getCurrentTime();
 	if (x < 0)
-	    exit(1);
+	    pingerClose();
+	exit(1);
+#ifdef _SQUID_MSWIN_
+	if (FD_ISSET(squid_sock, &R))
+#else
 	if (FD_ISSET(0, &R))
+#endif
 	    if (pingerReadRequest() < 0) {
 		debug(42, 0) ("Pinger exiting.\n");
+		pingerClose();
 		exit(1);
 	    }
 	if (FD_ISSET(icmp_sock, &R))
 	    pingerRecv();
+#ifdef _SQUID_MSWIN_
+	if (5 + last_check_time < squid_curtime) {
+	    if (send(squid_sock, (char *) &tv, 0, 0) < 0) {
+		debug(42, 0) ("Pinger exiting.\n");
+		pingerClose();
+		exit(1);
+	    }
+#else
 	if (10 + last_check_time < squid_curtime) {
-	    if (send(1, (char *) &tv, 0, 0) < 0)
+	    if (send(1, (char *) &tv, 0, 0) < 0) {
+		pingerClose();
 		exit(1);
+	    }
+#endif
 	    last_check_time = squid_curtime;
 	}
     }
